Lattice Grid Buy a licence

demo D226

Joining a second grid

Orders carry a customer id but no tier; a join brings it across from a customers grid, then groups revenue by tier

join: { with, on, select }

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">
<style>
  #books { display: flex; gap: 16px; }
  #orders { flex: 2; }
  #customers { flex: 1; }
  #orders > div, #customers > div { height: 300px; }
  #byTier { margin-top: 16px; }
</style>
<div id="app"></div>

<script type="module">
  import * as Vue from 'https://esm.sh/vue@3';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/vue.esm.min.js';

  const LatticeGrid = createLatticeGrid({ vue: Vue, createGrid });

  const USD = { style: 'currency', currency: 'USD', maximumFractionDigits: 0 };

  Vue.createApp({
    components: { LatticeGrid },
    data() {
      return {
        // The two sides: orders carry a customerId, and the tier lives on the customer.
        customers: {
          rowKey: 'id',
          columns: [{ field: 'id', title: 'ID' }, { field: 'name', title: 'Customer' }, { field: 'tier', title: 'Tier' }],
          rows: customerRows,  // e.g. [{ id: 'C0', name: 'Acme', tier: 'Enterprise' }, ...]
        },
        orders: {
          rowKey: 'id',
          toolPanel: { side: 'left', panels: ['filters', 'columns'] },
          columns: [
            { field: 'customerId', title: 'Customer' },
            { field: 'region', title: 'Region', filter: { type: 'set' } },
            { field: 'amount', title: 'Value', type: 'number', format: USD, total: 'sum' },
          ],
          rows: orderRows,  // e.g. [{ id: 'O0', customerId: 'C0', region: 'EMEA', amount: 1240 }, ...]
        },
        // Built once both source grids are live, which is why it waits for mounted().
        byTier: null,
      };
    },
    mounted() {
      // The join brings tier across from the customers grid onto each order, matching
      // customerId to id, then the group runs on that brought-across field. It runs
      // before grouping, so a group can read a field the join produced.
      this.byTier = {
        autoHeight: true,
        source: {
          mode: 'derived', from: this.$refs.orders.grid(), follow: 'filtered', refresh: 'live',
          join: { with: this.$refs.customers.grid(), on: { left: 'customerId', right: 'id' }, select: ['tier'] },
          groupBy: 'tier',
          select: { revenue: { of: 'amount', fn: 'sum' }, orders: { fn: 'count' } },
          sort: [{ col: 'revenue', dir: 'desc' }],
        },
        columns: [
          { field: 'tier', title: 'Tier' },
          { field: 'revenue', title: 'Revenue', type: 'number', format: USD },
          { field: 'orders', title: 'Orders', type: 'number' },
        ],
      };
    },
    template: `
      <div>
        <div id="books">
          <div id="orders"><lattice-grid ref="orders" v-bind="orders" /></div>
          <div id="customers"><lattice-grid ref="customers" v-bind="customers" /></div>
        </div>
        <div id="byTier"><lattice-grid v-if="byTier" v-bind="byTier" /></div>
      </div>
    `,
  }).mount('#app');
</script>

Lattice Grid Buy a licence

demo D226

Joining a second grid

Orders carry a customer id but no tier; a join brings it across from a customers grid, then groups revenue by tier

join: { with, on, select }

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.27.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const USD = { style: 'currency', currency: 'USD', maximumFractionDigits: 0 };

  // The two sides: orders carry a customerId, and the tier lives on the customer.
  const customerColumns = [
    { field: 'id', title: 'ID' },
    { field: 'name', title: 'Customer' },
    { field: 'tier', title: 'Tier' },
  ];
  const orderColumns = [
    { field: 'customerId', title: 'Customer' },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'amount', title: 'Value', type: 'number', format: USD, total: 'sum' },
  ];
  const byTierColumns = [
    { field: 'tier', title: 'Tier' },
    { field: 'revenue', title: 'Revenue', type: 'number', format: USD },
    { field: 'orders', title: 'Orders', type: 'number' },
  ];

  const customerRows = [/* [{ id: 'C0', name: 'Acme', tier: 'Enterprise' }, ...] */];
  const orderRows = [/* [{ id: 'O0', customerId: 'C0', region: 'EMEA', amount: 1240 }, ...] */];

  function App() {
    const ordersRef = React.useRef(null);
    const customersRef = React.useRef(null);
    const [derived, setDerived] = React.useState(null);

    // The join brings tier across from the customers grid onto each order,
    // matching customerId to id, then the group runs on that brought-across
    // field. Both sides are live instances, reached through their refs, so the
    // roll-up follows the filters on the orders grid.
    React.useEffect(() => {
      const orders = ordersRef.current && ordersRef.current.grid;
      const customers = customersRef.current && customersRef.current.grid;
      if (orders && customers) {
        setDerived({
          mode: 'derived', from: orders, follow: 'filtered', refresh: 'live',
          join: { with: customers, on: { left: 'customerId', right: 'id' }, select: ['tier'] },
          groupBy: 'tier',
          select: { revenue: { of: 'amount', fn: 'sum' }, orders: { fn: 'count' } },
          sort: [{ col: 'revenue', dir: 'desc' }],
        });
      }
    }, []);

    return (
      <>
        <div style={{ display: 'flex', gap: '16px' }}>
          <LatticeGrid
            ref={ordersRef}
            rowKey="id"
            toolPanel={{ side: 'left', panels: ['filters', 'columns'] }}
            columns={orderColumns}
            rows={orderRows}
            style={{ flex: 2, height: '300px' }}
          />
          <LatticeGrid
            ref={customersRef}
            rowKey="id"
            columns={customerColumns}
            rows={customerRows}
            style={{ flex: 1, height: '300px' }}
          />
        </div>
        {derived && (
          <LatticeGrid
            autoHeight
            source={derived}
            columns={byTierColumns}
            style={{ marginTop: '16px' }}
          />
        )}
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Lattice Grid Buy a licence

demo D226

Joining a second grid

Orders carry a customer id but no tier; a join brings it across from a customers grid, then groups revenue by tier

join: { with, on, select }

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { CommonModule } from '@angular/common';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const USD = { style: 'currency', currency: 'USD', maximumFractionDigits: 0 };

// The two sides: orders carry a customerId, and the tier lives on the customer.
const customerColumns = [
  { field: 'id', title: 'ID' },
  { field: 'name', title: 'Customer' },
  { field: 'tier', title: 'Tier' },
];
const orderColumns = [
  { field: 'customerId', title: 'Customer' },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'amount', title: 'Value', type: 'number', format: USD, total: 'sum' },
];
const byTierColumns = [
  { field: 'tier', title: 'Tier' },
  { field: 'revenue', title: 'Revenue', type: 'number', format: USD },
  { field: 'orders', title: 'Orders', type: 'number' },
];

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [CommonModule, LatticeGridComponent],
  template:
    '<div style="display:flex;gap:16px">' +
    '  <lattice-grid #orders [config]="ordersGrid" style="flex:2;height:300px"></lattice-grid>' +
    '  <lattice-grid #customers [config]="customersGrid" style="flex:1;height:300px"></lattice-grid>' +
    '</div>' +
    '<lattice-grid *ngIf="byTier" [config]="byTier" style="display:block;margin-top:16px"></lattice-grid>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild('orders') ordersRef!: LatticeGridComponent;
  @ViewChild('customers') customersRef!: LatticeGridComponent;
  byTier: any = null;

  ordersGrid = { rowKey: 'id', toolPanel: { side: 'left', panels: ['filters', 'columns'] }, columns: orderColumns, rows: [/* orders */] };
  customersGrid = { rowKey: 'id', columns: customerColumns, rows: [/* customers */] };

  // The join brings tier across from the customers grid onto each order, matching
  // customerId to id, then the group runs on that brought-across field. Both sides
  // are live instances, so the roll-up follows the filters on the orders grid.
  ngAfterViewInit() {
    const orders = this.ordersRef.grid;
    const customers = this.customersRef.grid;
    this.byTier = {
      autoHeight: true,
      columns: byTierColumns,
      source: {
        mode: 'derived', from: orders, follow: 'filtered', refresh: 'live',
        join: { with: customers, on: { left: 'customerId', right: 'id' }, select: ['tier'] },
        groupBy: 'tier',
        select: { revenue: { of: 'amount', fn: 'sum' }, orders: { fn: 'count' } },
        sort: [{ col: 'revenue', dir: 'desc' }],
      },
    };
  }
}

bootstrapApplication(AppComponent);